# made by Sebastien RAMAGE sebastien.ramage@gmail.com
# This is a proof of concept to demonstrate how fast LibreOffice can start using Quickstarter
# Tested on LibreOffice 3.6.1 but should work on any release.

import uno
import sys,os
import time
import _winreg
import subprocess

program = 'swriter'
if len(sys.argv) > 1:
    program = sys.argv[1]


def install_faststart():
    python_path = os.path.join(os.path.dirname(SOFFICE_PATH),'python.exe')
    script_path = os.path.abspath(sys.argv[0])
    key = _winreg.OpenKey(_winreg.HKEY_CLASSES_ROOT, r'LibreOffice.CalcDocument.1\shell\open\command', 0, _winreg.KEY_WRITE)
    _winreg.SetValue(key, "", _winreg.REG_SZ, '"%s" "%s" "%%1"'%(python_path,script_path))
    _winreg.CloseKey(key)
    key = _winreg.OpenKey(_winreg.HKEY_CLASSES_ROOT, r'LibreOffice.WriterDocument.1\shell\open\command', 0, _winreg.KEY_WRITE)
    _winreg.SetValue(key, "", _winreg.REG_SZ, '"%s" "%s" "%%1"'%(python_path,script_path))
    _winreg.CloseKey(key)

def uninstall_faststart():
    path = os.path.dirname(SOFFICE_PATH)
    key = _winreg.OpenKey(_winreg.HKEY_CLASSES_ROOT, r'LibreOffice.CalcDocument.1\shell\open\command', 0, _winreg.KEY_WRITE)
    _winreg.SetValue(key, "", _winreg.REG_SZ, '"%s" -o "%%1"'%os.path.join(path,'scalc.exe'))
    _winreg.CloseKey(key)
    key = _winreg.OpenKey(_winreg.HKEY_CLASSES_ROOT, r'LibreOffice.WriterDocument.1\shell\open\command', 0, _winreg.KEY_WRITE)
    _winreg.SetValue(key, "", _winreg.REG_SZ, '"%s" -o "%%1"'%os.path.join(path,'swriter.exe'))
    _winreg.CloseKey(key)

def check_quickstart():
    global SOFFICE_PATH
    lst = os.popen('tasklist').read()
    if not 'soffice.bin' in lst:
        print 'Starting QuickStart'
        path = os.path.dirname(SOFFICE_PATH)
        path = os.path.join(path,'quickstart')
        subprocess.call(path)
    else:
        print 'QuickStart ok !'
        

def Find_Path():
    key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, r'SOFTWARE\LibreOffice\LibreOffice', 0, _winreg.KEY_READ)
    subkey = _winreg.EnumKey(key,0)
    _winreg.CloseKey(key)
    key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, r'SOFTWARE\LibreOffice\LibreOffice\%s'%subkey, 0, _winreg.KEY_READ)
    path = _winreg.QueryValueEx(key, "Path")[0]
    _winreg.CloseKey(key)
    return path

SOFFICE_PATH = Find_Path()

if program == '--install':
    install_faststart()
    sys.exit(0)

if program == '--uninstall':
    uninstall_faststart()
    sys.exit(0)
    
def connect():
    print 'Connecting to LibreOffice'
    localContext = uno.getComponentContext()
    resolver = localContext.ServiceManager.createInstanceWithContext( "com.sun.star.bridge.UnoUrlResolver",  localContext )
    remoteContext = resolver.resolve( "uno:socket,host=localhost,port=2002;urp;StarOffice.ComponentContext" )
    return remoteContext

def start_headless():
    print 'Starting headless service'
    global SOFFICE_PATH
    cmd = '''"%s" --accept="socket,host=localhost,port=2002;urp;StarOffice.ComponentContext" --nologo --headless --nofirststartwizard'''%SOFFICE_PATH
    subprocess.call(cmd)


check_quickstart()

# connect to the running office
try:
    ctx = connect()
except:
    print 'Failed to connect, headless service probably missing'
    start_headless()
    ctx = connect()
smgr = ctx.ServiceManager

# get the central desktop object
desktop = smgr.createInstanceWithContext( "com.sun.star.frame.Desktop",ctx)

prop = {}
if os.path.isfile(program):
    url = uno.systemPathToFileUrl(os.path.abspath(program))
else:
    url = 'private:factory/%s'%program
desktop.loadComponentFromURL(url, "_blank", 0, ())


